#ifndef Spieler_H
#define Spieler_H

#include <Bild.h>
#include <Datei.h>
#include <Random.h>

using namespace Framework;

enum SpielerTyp
{
	SPIELER,
	ZIEL,
	GEGNER
};

class Spieler
{
private:
	double xPos;
	double yPos;
	double xSpeed;
	double ySpeed;
	double durchlssig;
	int farbe;
	int ref;

public:
	// Konstruktor
	Spieler( SpielerTyp typ, int mapBr, int mapH, RandomGenerator *zRand );
	Spieler( SpielerTyp typ, Datei *zD );
	// Destruktor
	~Spieler();
	// nicht constant
	void tick( double z, int mapBr, int mapH, char tastenStnde );
	void render( Bild &zRObj );
	// constant
	bool berhrt( double px, double py ) const;
	int getX() const;
	int getY() const;
	void save( Datei *zD ) const;
	// Reference Counting
	Spieler *getThis();
	Spieler *release();
};

#endif